## qemu 8.1.3+ds

=== debian/changelog ===
qemu (1:8.1.3+ds-1ubuntu2) noble; urgency=medium

  * d/p/u/define-ubuntu-machine-types.patch: Remove -hpb Noble machine
    types, as they are not needed by OpenStack anymore. (LP: #2045592)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Mon, 04 Dec 2023 16:44:44 -0500

qemu (1:8.1.3+ds-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2044425, #2039700). Remaining changes:
    - qemu-kvm to systemd unit
      - d/qemu-kvm-init: script for QEMU KVM preparation modules, ksm,
        hugepages and architecture specifics
      - d/qemu-system-common.qemu-kvm.service: systemd unit to call
        qemu-kvm-init
      - d/qemu-system-common.install: install helper script
      - d/qemu-system-common.qemu-kvm.default: defaults for
        /etc/default/qemu-kvm
      - d/rules: call dh_installinit and dh_installsystemd for qemu-kvm
    - Distribution specific machine type
      (LP 1304107 1621042 1776189 1761372 1761372 1776189)
      - d/p/ubuntu/define-ubuntu-machine-types.patch: define distro machine
        types containing release versioned machine attributes
      - Add an info about -hpb machine type in debian/qemu-system-x86.NEWS
      - ubuntu-q35 alias added to auto-select the most recent q35 ubuntu type
    - Enable nesting by default
      - d/p/ubuntu/enable-svm-by-default.patch: Enable nested svm by default
        in qemu64 on amd
        [ No more strictly needed, but required for backward compatibility ]
    - tolerate ipxe size change on migrations to >=18.04 (LP 1713490)
      - d/p/ubuntu/pre-bionic-256k-ipxe-efi-roms.patch: old machine types
        reference 256k path
      - d/control-in: depend on ipxe-qemu-256k-compat-efi-roms to be able to
        handle incoming migrations from former releases.
    - Ease the use of module retention on upgrades (LP 1913421)
      - debian/qemu-block-extra.postinst: enable mount unit on install/upgrade
    - Remaining GCC-12 FTBFS (LP 1988710 + LP 1921664)
      + d/p/u/qboot-Disable-LTO-for-ELF-binary-build-step.patch:
        fix qboot FTBFS with LTO
    - d/p/u/lp2003673-*.patch: Enable passthrough of IBM Z crypto
      hardware to Secure Execution guests. (LP #2003673)
  * Drop changes:
    - d/rules: Incorporate the following changes from Debian unstable, in
      order to fix the FTBFS caused by -fcf-protection:
      + d/rules: move icons install rules to install-misc section
      + d/rules: stop running whole thing with dh, take back *-indep sequence
      + d/rules: implement arch-dependent install/build targets without dh too
      [ Fixed in Debian. ]
    - d/rules: Get rid of binary-helper target; explicitly invoke its
      commands under binary-{arch,indep}.  This makes the build succeed
      again in Ubuntu, where binary-helper wasn't being properly invoked.
      [ Fixed in Debian. ]
    - d/p/u/lp2003673-update-linux-headers-6.3rc5.patch,
      d/p/u/lp2003673-update-linux-headers-6.5rc1.patch,
      d/p/u/lp2003673-s390x-fix-missing-subsystem-reset-registration.patch:
      Drop some of the patches to Enable passthrough of IBM Z crypto
      hardware to Secure Execution guests. (LP #2003673)
      [ Applied upstream. ]

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 22 Nov 2023 21:34:19 -0500

qemu (1:8.1.3+ds-1) unstable; urgency=medium

  * new upstream stable/bugfix release
  * remove patches applied upstream:
   - linux-user-Fixes-for-zero_bss.patch
   - target-mips-Fix-MSA-BZ-BNZ-opcodes-displacement.patch
   - hw-ide-reset-cancel-async-DMA-operation-before-reset.patch
  * d/control, d/qemu-system-gui.install: enable pipewire audio support
    (Closes: #1055221)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 22 Nov 2023 17:56:06 +0300

qemu (1:8.1.2+ds-1) unstable; urgency=medium

  * upstream 8.1.2 stable/bugfix release
  * remove all stable-staging/ patches and two more
    (all included into 8.1.2)
  * d/rules: microvm build: do not explicitly enable avx2

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 17 Oct 2023 09:44:39 +0300

qemu (1:8.1.1+ds-2) unstable; urgency=medium

  * d/rules: fix binary target to produce both arch and indep
    binaries instead of omitting indep one(s)
  * d/patches: sync with current staging-8.1 branch, many new fixes
  * additional fixes:
    +hw-ide-ahci-fix-legacy-software-reset.patch
    +target-mips-Fix-MSA-BZ-BNZ-opcodes-displacement.patch
    +hw-ide-reset-cancel-async-DMA-operation-before-reset.patch

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 08 Oct 2023 12:28:55 +0300

qemu (1:8.1.1+ds-1) unstable; urgency=medium

  * new upstream stable/bugfix release
  * remove all stable-staging/ patches, keep
    softmmu-Use-async_run_on_cpu-in-tcg_commit.patch
  * vfio-display-fix-missing-update-to-set-backing-field.patch
  * scsi-disk-disallow-small-block-sizes-CVE-2023-42467.patch
    (Closes: #1051899, CVE-2023-42467)
  * migration-qmp-Fix-crash-on-setting-tls-authz-with-nu.patch
  * d/patches/move-vl-opts/ - stop linking everything with async-teardown.c,
    un-FTBFS on ia64
  * d/control: minor: remove old todo comments
  * d/control: disable rbd (ceph) on 32bit platforms (Closes: #1053172)
  * d/control: enable rbd on riscv64 once it's built there
  * d/copyright: also remove subprojects/dtc

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 01 Oct 2023 22:11:24 +0300

qemu (1:8.1.0+ds-6) unstable; urgency=medium

  * re-enable softmmu-Use-async_run_on_cpu-in-tcg_commit.patch
  * add https://www.mail-archive.com/qemu-devel@nongnu.org/msg989073.html
    fixing https://gitlab.com/qemu-project/qemu/-/issues/1866
  * d/rules: reorder some definitions to evaluate in proper order

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 20 Sep 2023 23:31:59 +0300

qemu (1:8.1.0+ds-5) unstable; urgency=medium

  * disable softmmu-Use-async_run_on_cpu-in-tcg_commit.patch
    The change in softmmu-Use-async_run_on_cpu-in-tcg_commit.patch
    which is a fix for https://gitlab.com/qemu-project/qemu/-/issues/1864


=== debian/control ===
# autogenerated file, please edit debian/control-in
Source: qemu
Section: otherosfs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 13),
 python3:any,
 meson (>> 0.63.0~), ninja-build,
 flex, bison,
Build-Depends-Arch:
# In comments below we also specify (system-specific) arguments
# to qemu's configure script, -- optional features which depend
# on build-dependencies.
 python3-venv,
# --enable-docs
# for python3-sphinx:native see #995622
 texinfo, python3-sphinx:native, python3-sphinx-rtd-theme,
# always needed
 libglib2.0-dev,
 zlib1g-dev,
# iasl (from acpica-tools) is used only in a single test these days, not for building
# acpica-tools,
# libcapstone is in universe in ubuntu
# --enable-linux-aio	linux-any
 libaio-dev            [linux-any],
# libsndio is in universe in ubuntu
# --disable-sndio
# --audio-drv-list=pipewire,pa,alsa,jack,oss,sdl	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
##--audio-drv-list=pa,oss	kfreebsd-any
 libjack-dev  [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libpulse-dev,
 libasound2-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libpipewire-0.3-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# for virtfs (now in libc6)
# --enable-attr
# --enable-bpf	linux-any
 libbpf-dev	[linux-any],
# --enable-brlapi	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libbrlapi-dev         [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-virtfs	linux-any
# needed for virtfs
# --enable-cap-ng	linux-any
 libcap-ng-dev         [linux-any],
# --enable-curl
 libcurl4-gnutls-dev,
# --enable-fdt
 libfdt-dev,
# --enable-fuse
 libfuse3-dev,
# --enable-gnutls
 gnutls-dev,
# --enable-gtk --enable-vte	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libgtk-3-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libvte-2.91-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-libiscsi
 libiscsi-dev,
# --enable-curses	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libncurses-dev        [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-virglrenderer	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libvirglrenderer-dev          [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-opengl	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libepoxy-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libdrm-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
 libgbm-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-libnfs
 libnfs-dev,
# --enable-numa	i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64
 libnuma-dev   [i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64],
# --enable-smartcard
 libcacard-dev,
 libpixman-1-dev,
# --enable-rbd		amd64 arm64 mips64el ppc64el ppc64 riscv64 s390x sparc64
 librbd-dev            [amd64 arm64 mips64el ppc64el ppc64 riscv64 s390x sparc64],
# gluster is 64bit-only: #1039604
# --enable-glusterfs	 amd64 arm64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64
 libglusterfs-dev	[amd64 arm64 ppc64el ppc64 riscv64 mips64el s390x ia64 sparc64],
# --enable-vnc-sasl
 libsasl2-dev,
# --enable-sdl	amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
 libsdl2-dev [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32],
# --enable-seccomp	amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x x32
 libseccomp-dev        [amd64 arm64 armel armhf i386 mips64el mipsel ppc64 ppc64el powerpc riscv64 s390x x32],
# --enable-slirp
 libslirp-dev,
# --enable-spice	 amd64 arm64 armel armhf i386 mips64el mipsel ppc64el x32
 libspice-server-dev	[amd64 arm64 armel armhf i386 mips64el mipsel ppc64el x32],
# --enable-rdma		linux-any
 librdmacm-dev [linux-any], libibverbs-dev [linux-any], libibumad-dev [linux-any],
# --enable-linux-io-uring	linux-any
 liburing-dev                  [linux-any],
# --enable-libusb	linux-any
 libusb-1.0-0-dev      [linux-any],
# --enable-usb-redir	linux-any
 libusbredirparser-dev [linux-any],
# --enable-libssh
 libssh-dev,
# --enable-zstd
 libzstd-dev,
# vde is debian-only since ubuntu/vde2 is in universe
 libxen-dev [linux-amd64],
# --enable-nettle
 nettle-dev,
# other optional features we enable
# --enable-libudev
# needed for qga?
 libudev-dev [linux-any],
# --enable-vnc
# --enable-vnc-jpeg
 libjpeg-dev,
# --enable-png
 libpng-dev,
# --enable-libpmem	amd64 arm64
 libpmem-dev           [amd64 arm64],
# --enable-kvm		linux-any
# --enable-vhost-net	linux-any	# is it really linux-specific?
##--enable-lzo todo, for (memory) dumps
##--enable-netmap todo bsd
##--enable-xen-pci-passthrough todo
## auth-pam - for auth for vnc&Co using PAM
#
# the testsuite:
#XXX-cyclic-test-dep-dak-bug seabios [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] <!nocheck>,
# ipxe-qemu [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] <!nocheck>,
# various firmware files (kvmvapic.bin &Co), older qemu-system-data should work
#XXX-cyclic-test-dep-dak-bug qemu-system-data [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] <!nocheck>,
Build-Depends-Indep:
# pc-bios/*.dts => *.dtb (PPC firmware)
 device-tree-compiler,
 gcc-s390x-linux-gnu,
# qemu-palcode/palcode-clipper
 gcc-alpha-linux-gnu,
# u-boot code
 gcc-powerpc-linux-gnu, bc,
# skiboot firmware, openbios
 gcc-powerpc64-linux-gnu,
# skiboot includes <openssl/something.h>
 libssl-dev,
# openbios
 gcc-sparc64-linux-gnu, fcode-utils, xsltproc,
# hppa-firmware
 gcc-hppa-linux-gnu,
# opensbi
 gcc-riscv64-linux-gnu,
# vbootrom/npcm7xx_bootrom
 gcc-arm-none-eabi,
Build-Conflicts: oss4-dev
Standards-Version: 4.6.1
Homepage: http://www.qemu.org/
Rules-Requires-Root: binary-targets
XS-Debian-Vcs-Browser: https://salsa.debian.org/qemu-team/qemu
XS-Debian-Vcs-Git: https://salsa.debian.org/qemu-team/qemu.git
Vcs-Browser: https://git.launchpad.net/ubuntu/+source/qemu
Vcs-Git: https://git.launchpad.net/ubuntu/+source/qemu

Package: qemu-system
Architecture: amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: foreign
Build-Profiles: <!pkg.qemu.omit-system>
Depends: ${misc:Depends},
 qemu-system-arm,
 qemu-system-mips,
 qemu-system-ppc,
 qemu-system-sparc,
 qemu-system-x86,
 qemu-system-s390x,
 qemu-system-misc
Description: QEMU full system emulation binaries
 QEMU is a fast processor emulator: currently the package supports Alpha, ARM,
 CRIS, i386, LoongArch, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, RISC-V,
 S390x, SH4, SPARC, x86-64, Xtensa and other emulations. By using dynamic
 translation it achieves reasonable speed while being easy to port on new host
 CPUs.
 .
 This metapackage provides the full system emulation binaries for all supported
 targets, by depending on all per-architecture system emulation packages which
 QEMU supports.

Package: qemu-block-extra
Architecture: amd64 arm arm64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 m68k mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc sparc64 x32
Multi-Arch: no
Depends: ${misc:Depends}, ${shlibs:Depends},
# we need to ensure qemu-block-extra is upgraded with qemu-system-* or qemu-utils
 qemu-system-any (= ${binary:Version}) [amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32] | qemu-utils (= ${binary:Version}),
Enhances: qemu-utils, qemu-system-misc,
 qemu-system-arm, qemu-system-mips, qemu-system-sparc, qemu-system-x86,
Description: extra block backend modules for qemu-system and qemu-utils
 QEMU is a fast processor emulator: currently the package supports Alpha, ARM,
 CRIS, i386, LoongArch, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, RISC-V,
 S390x, SH4, SPARC, x86-64, Xtensa and other emulations. By using dynamic
 translation it achieves reasonable speed while being easy to port on new host
 CPUs.
 .
 This package provides extra block device backend modules for qemu-system
 emulation and qemu-img from qemu-utils package, which are rarely used and
 has extra dependencies.

Package: qemu-system-data
Architecture: all
Multi-Arch: foreign
Conflicts: sgabios, qemu-skiboot, openbios-sparc, openbios-ppc, qemu-slof,
Replaces:  sgabios, openbios-sparc, openbios-ppc, qemu-slof,
 qemu-system-ppc (<< 1:6.1-4~),
Breaks: qemu-system-ppc (<< 1:6.1-4~),
Provides: qemu-keymaps, sgabios, qemu-skiboot, openbios-sparc, openbios-ppc, qemu-slof,
Depends: ${misc:Depends}
Description: QEMU full system emulation (data files)
 This package provides architecture-neutral data files
 (such as keyboard definitions, icons) for system-mode
 QEMU emulation (qemu-system-*) packages.

Package: qemu-system-common
Architecture: amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
Multi-Arch: no
Build-Profiles: <!pkg.qemu.omit-system>
Breaks: libvirt-daemon (<< 7.2.0-1)
Depends: ${misc:Depends}, ${shlibs:Depends},
# to fix wrong acl for newly created device node on ubuntu:
 acl
Description: QEMU full system emulation binaries (common files)
 QEMU is a fast processor emulator: currently the package supports Alpha, ARM,
 CRIS, i386, LoongArch, M68k (ColdFire), MicroBlaze, MIPS, PowerPC, RISC-V,
 S390x, SH4, SPARC, x86-64, Xtensa and other emulations. By using dynamic
 translation it achieves reasonable speed while being easy to port on new host
 CPUs.
 .
 This package provides common files needed for target-specific
 full system emulation (qemu-system-*) packages.

Package: qemu-system-gui
Architecture: amd64 arm arm64 armel armhf i386 mips mips64 mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
#XXX M-A: same does not really work for now due to /usr/lib/qemu/vhost-user-gpu
#XXX we'll deal with this if some actual need arises,
#XXX by moving that binary back to q-s-common or packaging it separately
#Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
# ui-* depends on ui-opengl
 qemu-system-modules-opengl (= ${binary:Version}),

=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# stop python from generating .pyc caches
export PYTHONDONTWRITEBYTECODE=1

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
VENDOR := UBUNTU
DEB_BUILD_PARALLEL = yes
else
VENDOR := DEBIAN
endif

# get DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

ifeq ($(and ${DEB_HOST_MULTIARCH},${DEB_HOST_ARCH}),)
# Fast version of dpkg/architecture.mk defining all vars in one go
   $(foreach d, $(shell dpkg-architecture | sed 's/=/?=/'), $(eval export $d))
endif

# we build in a sub-subdir so strip that from file paths too
export DEB_CFLAGS_MAINT_APPEND = -ffile-prefix-map=../../=

# Disable LTO on non-amd64 builds, see:
# https://bugs.launchpad.net/ubuntu/+source/qemu/+bug/1921664
# https://bugzilla.redhat.com/show_bug.cgi?id=1952483
ifneq ($(DEB_HOST_ARCH),amd64)
  export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

# get CFLAGS LDFLAGS etc (should come after DEB_*MAINT*)
include /usr/share/dpkg/buildflags.mk

# Host architectures we produce packages for.
# when changing this list, check d/control-in too, if any changes
# needs to be done for build deps and --enable options.
system-arch-linux = \
	amd64 arm arm64 armel armhf i386 mips mipsel mips64 mips64el \
	powerpc powerpcspe ppc64 ppc64el riscv64 s390x sparc sparc64 x32
system-arch = ${system-arch-linux}
user-arch = \
	amd64 arm arm64 armel armhf i386 mips mipsel mips64 mips64el \
	ppc64 ppc64el riscv64 s390x sparc sparc64 x32
utils-arch = $(sort ${system-arch} ${user-arch} ia64 hppa m68k sh4 \
	kfreebsd-amd64 kfreebsd-i386)
# subset of system-arch
spice-arch = amd64 i386 arm64 armel armhf mips64el mipsel ppc64el x32

# DEB_BUILD_OPTIONS=parallel=N
MAKEFLAGS += $(subst parallel=,-j,$(filter parallel=%,${DEB_BUILD_OPTIONS}))

# verbose build
V = $(if $(filter terse, ${DEB_BUILD_OPTIONS}),,1)

NINJA = ninja $(if $V,-v) $(or $(filter -j%,${MAKEFLAGS}),-j1)

# list of packages we're supposed to build
BUILD_PACKAGES := $(shell dh_listpackages)

enable-system = $(if $(filter qemu-system,${BUILD_PACKAGES}),y)
enable-user = $(if $(filter qemu-user,${BUILD_PACKAGES}),y)
enable-user-static = $(if $(filter qemu-user-static,${BUILD_PACKAGES}),y)

QEMU_XEN = /usr/libexec/xen-qemu-system-i386
PKGVERSION = Debian ${DEB_VERSION}
SAVEMODDIR = /run/qemu/$(shell echo -n "${PKGVERSION}" | tr --complement '[:alnum:]+-.~' '_')
sysdataidir = debian/qemu-system-data/usr/share/qemu
libdir = /usr/lib/${DEB_HOST_MULTIARCH}
FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu

ALPHAEV67_CROSSPFX = alpha-linux-gnu-
PPC_CROSSPFX = powerpc-linux-gnu-
PPC64_CROSSPFX = powerpc64-linux-gnu-
RISCV64_CROSSPFX = riscv64-linux-gnu-
ARM_CROSSPFX = arm-none-eabi-

extra-cflags = ${CFLAGS} ${CPPFLAGS}
extra-ldflags = ${LDFLAGS} -Wl,--as-needed
# we add another set of configure options from debian/control
common_configure_opts = \
	--with-pkgversion="$(PKGVERSION)" \
	--extra-cflags="${extra-cflags}" \
	--extra-ldflags="${extra-ldflags}" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=${libdir} \
	--libexecdir=/usr/lib/qemu \
	--firmwarepath=${FIRMWAREPATH} \
	--localstatedir=/var \
	--disable-install-blobs \
	--disable-strip \
	--localstatedir=/var \
	--disable-download \

# this disables building of qemu-keymap tool (!)
# qemu-keymap might be helpful for qemu-system -k <lang>
# but is -k flag useful these days?
common_configure_opts += --disable-xkbcommon

# pvrdma is an extension/optimisation for vmxnet3 vmware virtual network
# adapter. This piece of code seems to be buggy and poorly maintained,
# resulting in numerous security issues which comes unfixed for long time.
# This device isn't native for qemu.  # Just disable it for now.
common_configure_opts += --disable-pvrdma

# Cross compiling support
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
common_configure_opts  += --cross-prefix=$(DEB_HOST_GNU_TYPE)-
endif

comma:=,

# qemu-system (softmmu) targets, in multiple packages
# For each package:
#  system-archlist-$pkg - list qemu architectues which should go to this pkg
#  system-kvmcpus-$pkg  - list of ${DEB_HOST_ARCH_CPU}s where we create
#                         kvm link for this package
# For each of ${system-archlist-*}, optional:
#  system-alias-$qcpu   - aliases for this qemu architecture
# For each of ${system-kvmcpus-*}, mandatory:
#  system-kvmlink-$dcpu - where to point kvm link for this ${DEB_HOST_ARCH_CPU}

system-archlist-arm = aarch64 arm
system-alias-aarch64 = arm64
system-alias-arm = armel armhf
system-kvmcpus-arm = arm64 arm
system-kvmlink-arm64 = aarch64
system-kvmlink-arm = arm

system-archlist-mips = mips mipsel mips64 mips64el

system-archlist-ppc = ppc ppc64
system-alias-ppc = powerpc
system-alias-ppc64 = ppc64le ppc64el
system-kvmcpus-ppc = ppc64 ppc64el powerpc
system-kvmlink-ppc64 = ppc64
system-kvmlink-ppc64el = ppc64
system-kvmlink-powerpc = ppc

system-archlist-sparc = sparc sparc64

system-s390x = $(if $(filter ${VENDOR},UBUNTU),s390x)

system-archlist-s390x = ${system-s390x}
system-kvmcpus-s390x = s390x
system-kvmlink-s390x = s390x

system-archlist-x86 = i386 x86_64
system-alias-x86_64 = amd64
system-kvmcpus-x86 = amd64 i386
system-kvmlink-amd64 = x86_64
system-kvmlink-i386 = x86_64

system-archlist-misc = alpha avr cris hppa m68k loongarch64 \
		microblaze microblazeel nios2 or1k riscv32 riscv64 rx sh4 sh4eb \
		$(if ${system-s390x},,s390x) \
		tricore xtensa xtensaeb
system-alias-loongarch64 = loong64
system-kvmcpus-misc = $(if ${system-s390x},,s390x)

system-packages = arm mips ppc sparc x86 ${system-s390x} misc

# install-system qemu-system-$pkg, ${system-archlist-$pkg}, kvm-link
# install qemu-arch-list binaries with manpages and aliases into pkg
# install kvm link to qemu-system-${kvm-link} if it is not empty
# fills in qemu:Provides and qemu:archlist substvars
define install-system
	# installing $1
	dh_installdirs -p $1 usr/bin usr/share/man/man1
	mv -t debian/$1/usr/bin/ $(addprefix debian/tmp/usr/bin/qemu-system-,$2)
$(foreach q,$2,\
	@echo ".so man1/qemu-system.1" > debian/$1/usr/share/man/man1/qemu-system-$q.1
    $(foreach a,${system-alias-$q},\
	dh_link -p $1 usr/bin/qemu-system-$q usr/bin/qemu-system-$a
	dh_link -p $1 usr/share/man/man1/qemu-system-$q.1 usr/share/man/man1/qemu-system-$a.1
))
$(if $3,\
	dh_link -p $1 usr/bin/$3 usr/bin/kvm
	dh_link -p $1 usr/share/man/man1/$3.1 usr/share/man/man1/kvm.1
)
	echo 'qemu:Provides=$(if $3,qemu-kvm (=${DEB_VERSION})${comma})\
	 $(patsubst %,qemu-system-% (=${DEB_VERSION})${comma}, any $2 $(foreach q,$2,${system-alias-$q}))' \
	    | tr _ - >> debian/$1.substvars
# construct list `arch1 arch2 (alias) arch3..' for Description
# and word-wrap it into two lines if too long
	list='$(foreach q,$2,$q$(if ${system-alias-$q}, (${system-alias-$q})))'; \
	  len2=$$(($${#list}/2)); \
	  if [ $$len2 -gt 36 ]; then \
	    while expr substr "$$list" $$len2 1 != " " >/dev/null; do len2=$$(($$len2+1)); done; \
	    list="$$(expr substr "$$list" 1 $$(($$len2-1)))\$${Newline} $$(expr substr "$$list" $$(($$len2+1)) $$len2)"; \
	  fi; \
	  echo "qemu:archlist=$$list" >> debian/$1.substvars
	dh_installdocs -p $1 --link-doc=qemu-system-common
endef

sysdata-components :=
qemu-builds :=

# several builds of qemu binaries:

##############################################
# main system and tools build
configure-qemu: b/qemu/configured
b/qemu/configured: configure
	rm -rf b/qemu; mkdir -p b/qemu
	cd b/qemu && \
	    ../../configure ${common_configure_opts} \
		--$(if ${enable-system},enable,disable)-system \
		--disable-user --disable-linux-user \
		--enable-tools \
		--disable-xen \
		--enable-modules \
		$(if ${enable-system},--enable-module-upgrades) \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		${QEMU_CONFIGURE_OPTIONS}
	touch $@

build-qemu: b/qemu/built

## qemu 8.2.0%2Bds

=== debian/changelog ===
qemu (1:8.2.0+ds-1deepin13) unstable; urgency=medium

  * fix qemu fmt issue.

 -- Xianglai Li <lixianglai@loongson.cn>  Fri, 28 Mar 2025 17:39:03 +0800

qemu (1:8.2.0+ds-1deepin12) unstable; urgency=medium

  * Add recommends for qemu-efi-loongarch64.

 -- Mingcong Bai <baimingcong@uniontech.com>  Fri, 07 Mar 2025 14:04:59 +0800

qemu (1:8.2.0+ds-1deepin11) unstable; urgency=medium

  * Synchronize the latest patch of upstream loongarch.

 -- Xianglai Li <lixianglai@loongson.cn>  Tue, 25 Feb 2025 19:37:11 +0800

qemu (1:8.2.0+ds-1deepin10) unstable; urgency=medium

  * virtio-net: Fix network stall at the host side waiting for kick.

 -- hanliyang <hanliyang@hygon.cn>  Mon, 13 Jan 2025 10:13:11 +0800

qemu (1:8.2.0+ds-1deepin9) unstable; urgency=medium

  * Enable loongarch64 targets.

 -- Mingcong Bai <baimingcong@uniontech.com>  Wed, 08 Jan 2025 10:08:10 +0000

qemu (1:8.2.0+ds-1deepin8) unstable; urgency=medium

  * Support reuse ASID for Hygon CSV.
  * Support kernel-hashes and secret injection for Hygon CSV3

 -- hanliyang <hanliyang@hygon.cn>  Fri, 15 Nov 2024 11:57:11 +0800

qemu (1:8.2.0+ds-1deepin7) unstable; urgency=medium

  * Supports running Hygon TKM in CSV virtual machine.

 -- xiongmengbiao <xiongmengbiao@hygon.cn>  Thu Oct 17 15:07:25 2024 +0800

qemu (1:8.2.0+ds-1deepin6) unstable; urgency=medium

  * Add hw/vfio/hct device, which support using ccp in VM.

 -- yangdepei <yangdepei@hygon.cn>  Fri, 18 Oct 2024 16:56:07 +0800

qemu (1:8.2.0+ds-1deepin5) unstable; urgency=medium

  * Support Hygon CSV3 VM, support live migration for Hygon CSV3 VM.

 -- hanliyang <hanliyang@hygon.cn>  Tue, 09 Oct 2024 13:52:00 +0800

qemu (1:8.2.0+ds-1deepin4) unstable; urgency=medium

  * Drop powerpc64 system data (Skiboot, VoF, SLOF) as we don't provide
    cross toolchains for big-endian PowerPC targets.
  * Disable librbd (Ceph) support for riscv64 as it currently does not build.

 -- Mingcong Bai <baimingcong@uniontech.com>  Wed, 09 Oct 2024 15:16:20 +0800

qemu (1:8.2.0+ds-1deepin3) unstable; urgency=medium

  * Support live migration of Hygon CSV/CSV2 VM, support reboot CSV/CSV2 VM

 -- hanliyang <hanliyang@hygon.cn>  Tue, 3 Sep 2024 11:27:30 2024 +0800

qemu (1:8.2.0+ds-1deepin2) unstable; urgency=medium

  * Support hygon tkm key isolation.

 -- xiongmengbiao <xiongmengbiao@hygon.cn>  Mon Aug 26 14:27:11 2024 +0800

qemu (1:8.2.0+ds-1deepin1) unstable; urgency=medium

  * Drop palcode-clipper.
  * Restrict several B-D-InDep to amd64 only.

 -- Tianyu Chen <sweetyfish@deepin.org>  Tue, 26 Dec 2023 11:43:42 +0800

qemu (1:8.2.0+ds-1) unstable; urgency=medium

  * new upstream release 8.2.0
    Closes: #1013952
  * d/rules: re-enable building static-pie binaries (the default) for
    qemu-user-static again (formally Closes: #1053101, LP:#1908331)
  * d/rules: add --disable-pie for static build on i386 due to #1056739
  * d/control: qemu-system-x86 depends on seabios >>1.16.3-1 due to ahci fix
  * d/qemu-user-static.lintian-overrides: +shared-library-lacks-prerequisites
    for static-pie executables
  * d/rules: omit qemu-user-static package from dh_shlibdeps run
    since dpkg-shlibdeps complains about static-pie binaries
  * d/rules: fix bugzilla.redhat.com url (migrated to issues.redhat.com)
  * d/patches: remove patches applied upstream
  * d/patches, d/rules: use --disable-relocatable instead of a patch
  * d/patches: refresh disable-xen-on-x32.patch
  * d/control: --enable-pixman (which is optional now)
  * d/rules: vnc needs pixman too (for xen and microvm builds)
  * d/copyright: stop excluding subprojects/dtc (not included anymore)
  * d/source/lintian-overrides: +source-is-missing for vdso.so files

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 20 Dec 2023 18:21:19 +0300

## qemu 8.2.0+ds

=== meson_options.txt ===
# These options do not correspond to a --enable/--disable-* option
# on the configure script command line.  If you add more, list them in
# scripts/meson-buildoptions.py's SKIP_OPTIONS constant too.

option('qemu_suffix', type : 'string', value: 'qemu',
       description: 'Suffix for QEMU data/modules/config directories (can be empty)')
option('docdir', type : 'string', value : 'share/doc',
       description: 'Base directory for documentation installation (can be empty)')
option('qemu_firmwarepath', type : 'array', value : ['share/qemu-firmware'],
       description: 'search PATH for firmware files')
option('pkgversion', type : 'string', value : '',
       description: 'use specified string as sub-version of the package')
option('smbd', type : 'string', value : '',
       description: 'Path to smbd for slirp networking')
option('iasl', type : 'string', value : '',
       description: 'Path to ACPI disassembler')
option('tls_priority', type : 'string', value : 'NORMAL',
       description: 'Default TLS protocol/cipher priority string')
option('default_devices', type : 'boolean', value : true,
       description: 'Include a default selection of devices in emulators')
option('audio_drv_list', type: 'array', value: ['default'],
       choices: ['alsa', 'coreaudio', 'default', 'dsound', 'jack', 'oss', 'pa', 'pipewire', 'sdl', 'sndio'],
       description: 'Set audio driver list')
option('block_drv_rw_whitelist', type : 'string', value : '',
       description: 'set block driver read-write whitelist (by default affects only QEMU, not tools like qemu-img)')
option('block_drv_ro_whitelist', type : 'string', value : '',
       description: 'set block driver read-only whitelist (by default affects only QEMU, not tools like qemu-img)')
option('interp_prefix', type : 'string', value : '/usr/gnemul/qemu-%M',
       description: 'where to find shared libraries etc., use %M for cpu name')
option('fuzzing_engine', type : 'string', value : '',
       description: 'fuzzing engine library for OSS-Fuzz')
option('trace_file', type: 'string', value: 'trace',
       description: 'Trace file prefix for simple backend')
option('coroutine_backend', type: 'combo',
       choices: ['ucontext', 'sigaltstack', 'windows', 'auto'],
       value: 'auto', description: 'coroutine backend to use')

# Everything else can be set via --enable/--disable-* option
# on the configure script command line.  After adding an option
# here make sure to run "make update-buildoptions".

option('docs', type : 'feature', value : 'auto',
       description: 'Documentations build support')
option('fuzzing', type : 'boolean', value: false,
       description: 'build fuzzing targets')
option('gettext', type : 'feature', value : 'auto',
       description: 'Localization of the GTK+ user interface')
option('modules', type : 'feature', value : 'disabled',
       description: 'modules support (non Windows)')
option('module_upgrades', type : 'boolean', value : false,
       description: 'try to load modules from alternate paths for upgrades')
option('install_blobs', type : 'boolean', value : true,
       description: 'install provided firmware blobs')
option('sparse', type : 'feature', value : 'auto',
       description: 'sparse checker')
option('guest_agent', type : 'feature', value : 'auto',
       description: 'Build QEMU Guest Agent')
option('guest_agent_msi', type : 'feature', value : 'auto',
       description: 'Build MSI package for the QEMU Guest Agent')
option('tools', type : 'feature', value : 'auto',
       description: 'build support utilities that come with QEMU')
option('qga_vss', type : 'feature', value: 'auto',
       description: 'build QGA VSS support (broken with MinGW)')

option('malloc_trim', type : 'feature', value : 'auto',
       description: 'enable libc malloc_trim() for memory optimization')
option('malloc', type : 'combo', choices : ['system', 'tcmalloc', 'jemalloc'],
       value: 'system', description: 'choose memory allocator to use')

option('kvm', type: 'feature', value: 'auto',
       description: 'KVM acceleration support')
option('whpx', type: 'feature', value: 'auto',
       description: 'WHPX acceleration support')
option('hvf', type: 'feature', value: 'auto',
       description: 'HVF acceleration support')
option('nvmm', type: 'feature', value: 'auto',
       description: 'NVMM acceleration support')
option('xen', type: 'feature', value: 'auto',
       description: 'Xen backend support')
option('xen_pci_passthrough', type: 'feature', value: 'auto',
       description: 'Xen PCI passthrough support')
option('tcg', type: 'feature', value: 'enabled',
       description: 'TCG support')
option('plugins', type: 'boolean', value: false,
       description: 'TCG plugins via shared library loading')
option('debug_tcg', type: 'boolean', value: false,
       description: 'TCG debugging')
option('tcg_interpreter', type: 'boolean', value: false,
       description: 'TCG with bytecode interpreter (slow)')
option('safe_stack', type: 'boolean', value: false,
       description: 'SafeStack Stack Smash Protection (requires clang/llvm and coroutine backend ucontext)')
option('sanitizers', type: 'boolean', value: false,
       description: 'enable default sanitizers')
option('tsan', type: 'boolean', value: false,
       description: 'enable thread sanitizer')
option('stack_protector', type: 'feature', value: 'auto',
       description: 'compiler-provided stack protection')
option('cfi', type: 'boolean', value: false,
       description: 'Control-Flow Integrity (CFI)')
option('cfi_debug', type: 'boolean', value: false,
       description: 'Verbose errors in case of CFI violation')
option('multiprocess', type: 'feature', value: 'auto',
       description: 'Out of process device emulation support')
option('relocatable', type : 'boolean', value : 'true',
       description: 'toggle relocatable install')
option('vfio_user_server', type: 'feature', value: 'disabled',
       description: 'vfio-user server support')
option('dbus_display', type: 'feature', value: 'auto',
       description: '-display dbus support')
option('tpm', type : 'feature', value : 'auto',
       description: 'TPM support')

# Do not enable it by default even for Mingw32, because it doesn't
# work on Wine.
option('membarrier', type: 'feature', value: 'disabled',
       description: 'membarrier system call (for Linux 4.14+ or Windows')

option('avx2', type: 'feature', value: 'auto',
       description: 'AVX2 optimizations')
option('avx512f', type: 'feature', value: 'disabled',
       description: 'AVX512F optimizations')
option('avx512bw', type: 'feature', value: 'auto',
       description: 'AVX512BW optimizations')
option('keyring', type: 'feature', value: 'auto',
       description: 'Linux keyring support')
option('libkeyutils', type: 'feature', value: 'auto',
       description: 'Linux keyutils support')

option('af_xdp', type : 'feature', value : 'auto',
       description: 'AF_XDP network backend support')
option('attr', type : 'feature', value : 'auto',
       description: 'attr/xattr support')
option('auth_pam', type : 'feature', value : 'auto',
       description: 'PAM access control')
option('brlapi', type : 'feature', value : 'auto',
       description: 'brlapi character device driver')
option('bzip2', type : 'feature', value : 'auto',
       description: 'bzip2 support for DMG images')
option('cap_ng', type : 'feature', value : 'auto',
       description: 'cap_ng support')
option('blkio', type : 'feature', value : 'auto',
       description: 'libblkio block device driver')
option('bpf', type : 'feature', value : 'auto',
        description: 'eBPF support')
option('cocoa', type : 'feature', value : 'auto',
       description: 'Cocoa user interface (macOS only)')
option('curl', type : 'feature', value : 'auto',
       description: 'CURL block device driver')
option('gio', type : 'feature', value : 'auto',
       description: 'use libgio for D-Bus support')
option('glusterfs', type : 'feature', value : 'auto',
       description: 'Glusterfs block device driver')
option('hv_balloon', type : 'feature', value : 'auto',
       description: 'hv-balloon driver (requires Glib 2.68+ GTree API)')
option('libdw', type : 'feature', value : 'auto',
       description: 'debuginfo support')
option('libiscsi', type : 'feature', value : 'auto',
       description: 'libiscsi userspace initiator')
option('libnfs', type : 'feature', value : 'auto',
       description: 'libnfs block device driver')
option('mpath', type : 'feature', value : 'auto',
       description: 'Multipath persistent reservation passthrough')
option('numa', type : 'feature', value : 'auto',
       description: 'libnuma support')
option('iconv', type : 'feature', value : 'auto',
       description: 'Font glyph conversion support')
option('curses', type : 'feature', value : 'auto',
       description: 'curses UI')
option('gnutls', type : 'feature', value : 'auto',
       description: 'GNUTLS cryptography support')
option('nettle', type : 'feature', value : 'auto',
       description: 'nettle cryptography support')
option('gcrypt', type : 'feature', value : 'auto',
       description: 'libgcrypt cryptography support')
option('crypto_afalg', type : 'feature', value : 'disabled',
       description: 'Linux AF_ALG crypto backend driver')
option('libdaxctl', type : 'feature', value : 'auto',
       description: 'libdaxctl support')
option('libpmem', type : 'feature', value : 'auto',
       description: 'libpmem support')
option('libssh', type : 'feature', value : 'auto',
       description: 'ssh block device support')
option('libudev', type : 'feature', value : 'auto',
       description: 'Use libudev to enumerate host devices')
option('libusb', type : 'feature', value : 'auto',
       description: 'libusb support for USB passthrough')
option('linux_aio', type : 'feature', value : 'auto',
       description: 'Linux AIO support')
option('linux_io_uring', type : 'feature', value : 'auto',
       description: 'Linux io_uring support')
option('lzfse', type : 'feature', value : 'auto',
       description: 'lzfse support for DMG images')
option('lzo', type : 'feature', value : 'auto',
       description: 'lzo compression support')
option('rbd', type : 'feature', value : 'auto',
       description: 'Ceph block device driver')
option('opengl', type : 'feature', value : 'auto',
       description: 'OpenGL support')
option('rdma', type : 'feature', value : 'auto',
       description: 'Enable RDMA-based migration')
option('pvrdma', type : 'feature', value : 'auto',
       description: 'Enable PVRDMA support')
option('gtk', type : 'feature', value : 'auto',
       description: 'GTK+ user interface')
option('sdl', type : 'feature', value : 'auto',
       description: 'SDL user interface')
option('sdl_image', type : 'feature', value : 'auto',
       description: 'SDL Image support for icons')
option('seccomp', type : 'feature', value : 'auto',
       description: 'seccomp support')
option('smartcard', type : 'feature', value : 'auto',
       description: 'CA smartcard emulation support')
option('snappy', type : 'feature', value : 'auto',
       description: 'snappy compression support')
option('spice', type : 'feature', value : 'auto',
       description: 'Spice server support')
option('spice_protocol', type : 'feature', value : 'auto',
       description: 'Spice protocol support')
option('u2f', type : 'feature', value : 'auto',
       description: 'U2F emulation support')
option('canokey', type : 'feature', value : 'auto',
       description: 'CanoKey support')
option('usb_redir', type : 'feature', value : 'auto',
       description: 'libusbredir support')
option('l2tpv3', type : 'feature', value : 'auto',
       description: 'l2tpv3 network backend support')
option('netmap', type : 'feature', value : 'auto',
       description: 'netmap network backend support')
option('pixman', type : 'feature', value : 'auto',
       description: 'pixman support')
option('slirp', type: 'feature', value: 'auto',

=== roms/u-boot/arch/powerpc/Makefile ===
# SPDX-License-Identifier: GPL-2.0+

head-y := arch/powerpc/cpu/$(CPU)/start.o
head-$(CONFIG_MPC85xx) += arch/powerpc/cpu/mpc85xx/resetvec.o

libs-y += arch/powerpc/cpu/$(CPU)/
libs-y += arch/powerpc/cpu/
libs-y += arch/powerpc/lib/

=== debian/changelog ===
qemu (1:8.2.0+ds-4ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2048802, #2048776). Remaining changes:
    - qemu-kvm to systemd unit
      - d/qemu-kvm-init: script for QEMU KVM preparation modules, ksm,
        hugepages and architecture specifics
      - d/qemu-system-common.qemu-kvm.service: systemd unit to call
        qemu-kvm-init
      - d/qemu-system-common.install: install helper script
      - d/qemu-system-common.qemu-kvm.default: defaults for
        /etc/default/qemu-kvm
      - d/rules: call dh_installinit and dh_installsystemd for qemu-kvm
    - Distribution specific machine type
      (LP 1304107 1621042 1776189 1761372 1761372 1776189)
      - d/p/ubuntu/define-ubuntu-machine-types.patch: define distro machine
        types containing release versioned machine attributes
      - Add an info about -hpb machine type in debian/qemu-system-x86.NEWS
      - ubuntu-q35 alias added to auto-select the most recent q35 ubuntu type
    - Enable nesting by default
      - d/p/ubuntu/enable-svm-by-default.patch: Enable nested svm by default
        in qemu64 on amd
        [ No more strictly needed, but required for backward compatibility ]
    - tolerate ipxe size change on migrations to >=18.04 (LP 1713490)
      - d/p/ubuntu/pre-bionic-256k-ipxe-efi-roms.patch: old machine types
        reference 256k path
      - d/control-in: depend on ipxe-qemu-256k-compat-efi-roms to be able to
        handle incoming migrations from former releases.
    - Ease the use of module retention on upgrades (LP 1913421)
      - debian/qemu-block-extra.postinst: enable mount unit on install/upgrade
    - Remaining GCC-12 FTBFS (LP 1988710 + LP 1921664)
      + d/p/u/qboot-Disable-LTO-for-ELF-binary-build-step.patch:
        fix qboot FTBFS with LTO
  * Drop changes:
    - d/p/u/lp2003673-*.patch: Enable passthrough of IBM Z crypto
      hardware to Secure Execution guests. (LP #2003673)
      [ Incorporated by upstream on version 8.2.0. ]
  * Add changes:
    - d/rules: Enable/disable extra features on microvm
      variant. (LP: #2045594)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 10 Jan 2024 19:10:46 -0500

qemu (1:8.2.0+ds-4) unstable; urgency=medium

  * d/rules: fix "tail -20" usage
  * note-missing-module-pkg-name.diff: update, to be much more accurate
    No more sporadic warnings about missing audio backends etc
  * d/control: clarify qemu-system-gui and qemu-system-modules-* package
    descriptions a little bit (#1059457)
  * more fixups from the ML targetting stable:
   + hw-net-cadence_gem-fix-MDIO_OP_xxx-values.patch
   + tcg-ppc-use-new-registers-for-LQ-destination.patch
   + target-riscv-fix-mcycle-minstret-increment-behavior.patch
  * a bunch of hppa and seabios-hppa fixes targetting -stable for
    https://gitlab.com/qemu-project/qemu/-/issues/2044

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 04 Jan 2024 22:47:59 +0300

qemu (1:8.2.0+ds-3) unstable; urgency=medium

  * +virtio-net-correctly-copy-vnet-header-when-flushing-TX-CVE-2023-6693.patch
    Fix CVE-2023-6693 (virtio-net: stack buffer overflow in virtio_net_flush_tx)
  * +target-i386-the-sgx_epc_get_section-stub-is-reachable.patch
  * +target-xtensa-fix-OOB-TLB-entry-access.patch
  * d/rules: print last 20 lines of config.log & meson.log if ./configure fails

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 02 Jan 2024 15:54:35 +0300

qemu (1:8.2.0+ds-2) unstable; urgency=medium

  * include-ui-rect.h-fix-qemu_rect_init-mis-assignment.patch
    fixes virtio-gpu redraw issue (Closes: #1059211)
  * hw-vfio-fix-iteration-over-global-VFIODevice-list.patch
    fixes reboot issue with virtio-gpu
  * target-i386-do-not-re-compute-new-pc-with-CF_PCREL.patch
    fixes 4M edk2 stall in i386 tcg mode
  * block-fix-crash-when-loading-snapshot-on-inactive-no.patch
    fix possible assertion failure when loading snapshot

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 02 Jan 2024 12:10:14 +0300

=== debian/control ===
--- 
+++ 
@@ -70,6 +70,7 @@
  libnuma-dev   [i386 amd64 ia64 mips mipsel mips64 mips64el powerpc powerpcspe x32 ppc64 ppc64el arm64 sparc s390x riscv64],
 # --enable-smartcard
  libcacard-dev,
+# --enable-pixman
  libpixman-1-dev,
 # --enable-rbd		amd64 arm64 mips64el ppc64el ppc64 riscv64 s390x sparc64
  librbd-dev            [amd64 arm64 mips64el ppc64el ppc64 riscv64 s390x sparc64],

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 
 # Disable LTO on non-amd64 builds, see:
 # https://bugs.launchpad.net/ubuntu/+source/qemu/+bug/1921664
-# https://bugzilla.redhat.com/show_bug.cgi?id=1952483
+# https://issues.redhat.com/browse/RHEL-7385
 ifneq ($(DEB_HOST_ARCH),amd64)
   export DEB_BUILD_MAINT_OPTIONS += optimize=-lto
 endif
@@ -96,6 +96,7 @@
 	--disable-strip \
 	--localstatedir=/var \
 	--disable-download \
+	--disable-relocatable \
 
 # this disables building of qemu-keymap tool (!)
 # qemu-keymap might be helpful for qemu-system -k <lang>
@@ -218,7 +219,4 @@
 		$(if ${enable-system},--enable-module-upgrades) \
 		$(shell sh debian/extract-config-opts \
 		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
-		${QEMU_CONFIGURE_OPTIONS}
-	touch $@
-
-build-qemu: b/qemu/built
+		${QEMU_CONFIGURE_OPTIONS} || \
